import { createElement } from 'react';
import { render } from 'react-dom';
import { v1 } from 'uuid';
import MUIDataTable from 'mui-datatables';
import { Component, Input, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MuiDatatablesComponent = /** @class */ (function () {
    function MuiDatatablesComponent() {
    }
    /**
     * @protected
     * @return {?}
     */
    MuiDatatablesComponent.prototype.getRootDomNode = /**
     * @protected
     * @return {?}
     */
    function () {
        /** @type {?} */
        var node = document.getElementById(this.rootDomID);
        return node;
    };
    /**
     * @protected
     * @return {?}
     */
    MuiDatatablesComponent.prototype.getProps = /**
     * @protected
     * @return {?}
     */
    function () {
        var _a = this, title = _a.title, columns = _a.columns, data = _a.data, options = _a.options;
        return {
            title: title,
            columns: columns,
            data: data,
            options: options
        };
    };
    /**
     * @private
     * @return {?}
     */
    MuiDatatablesComponent.prototype.isMounted = /**
     * @private
     * @return {?}
     */
    function () {
        return !!this.rootDomID;
    };
    /**
     * @protected
     * @return {?}
     */
    MuiDatatablesComponent.prototype.render = /**
     * @protected
     * @return {?}
     */
    function () {
        if (this.isMounted()) {
            render(createElement(MUIDataTable, this.getProps()), this.getRootDomNode());
        }
    };
    /**
     * @return {?}
     */
    MuiDatatablesComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.rootDomID = v1();
    };
    /**
     * @return {?}
     */
    MuiDatatablesComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        this.render();
    };
    /**
     * @return {?}
     */
    MuiDatatablesComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.render();
    };
    /**
     * @return {?}
     */
    MuiDatatablesComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        // Uncomment if Angular 4 issue that ngOnDestroy is called AFTER DOM node removal is resolved
        // ReactDOM.unmountComponentAtNode(this.getRootDomNode())
    };
    MuiDatatablesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-mui-datatable',
                    template: '<span [id]="rootDomID"></span>'
                }] }
    ];
    MuiDatatablesComponent.propDecorators = {
        title: [{ type: Input }],
        columns: [{ type: Input }],
        data: [{ type: Input }],
        options: [{ type: Input }]
    };
    return MuiDatatablesComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxMuiDatatablesModule = /** @class */ (function () {
    function NgxMuiDatatablesModule() {
    }
    NgxMuiDatatablesModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [MuiDatatablesComponent],
                    imports: [],
                    exports: [MuiDatatablesComponent]
                },] }
    ];
    return NgxMuiDatatablesModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { MuiDatatablesComponent, NgxMuiDatatablesModule };

//# sourceMappingURL=ngx-mui-datatables.js.map