(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('react-dom'), require('uuid'), require('mui-datatables'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-mui-datatables', ['exports', 'react', 'react-dom', 'uuid', 'mui-datatables', '@angular/core'], factory) :
    (factory((global['ngx-mui-datatables'] = {}),global.React,global.ReactDOM,global.uuid,global.MUIDataTable,global.ng.core));
}(this, (function (exports,React,ReactDOM,uuid,MUIDataTable,core) { 'use strict';

    MUIDataTable = MUIDataTable && MUIDataTable.hasOwnProperty('default') ? MUIDataTable['default'] : MUIDataTable;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MuiDatatablesComponent = /** @class */ (function () {
        function MuiDatatablesComponent() {
        }
        /**
         * @protected
         * @return {?}
         */
        MuiDatatablesComponent.prototype.getRootDomNode = /**
         * @protected
         * @return {?}
         */
            function () {
                /** @type {?} */
                var node = document.getElementById(this.rootDomID);
                return node;
            };
        /**
         * @protected
         * @return {?}
         */
        MuiDatatablesComponent.prototype.getProps = /**
         * @protected
         * @return {?}
         */
            function () {
                var _a = this, title = _a.title, columns = _a.columns, data = _a.data, options = _a.options;
                return {
                    title: title,
                    columns: columns,
                    data: data,
                    options: options
                };
            };
        /**
         * @private
         * @return {?}
         */
        MuiDatatablesComponent.prototype.isMounted = /**
         * @private
         * @return {?}
         */
            function () {
                return !!this.rootDomID;
            };
        /**
         * @protected
         * @return {?}
         */
        MuiDatatablesComponent.prototype.render = /**
         * @protected
         * @return {?}
         */
            function () {
                if (this.isMounted()) {
                    ReactDOM.render(React.createElement(MUIDataTable, this.getProps()), this.getRootDomNode());
                }
            };
        /**
         * @return {?}
         */
        MuiDatatablesComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.rootDomID = uuid.v1();
            };
        /**
         * @return {?}
         */
        MuiDatatablesComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                this.render();
            };
        /**
         * @return {?}
         */
        MuiDatatablesComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                this.render();
            };
        /**
         * @return {?}
         */
        MuiDatatablesComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                // Uncomment if Angular 4 issue that ngOnDestroy is called AFTER DOM node removal is resolved
                // ReactDOM.unmountComponentAtNode(this.getRootDomNode())
            };
        MuiDatatablesComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-mui-datatable',
                        template: '<span [id]="rootDomID"></span>'
                    }] }
        ];
        MuiDatatablesComponent.propDecorators = {
            title: [{ type: core.Input }],
            columns: [{ type: core.Input }],
            data: [{ type: core.Input }],
            options: [{ type: core.Input }]
        };
        return MuiDatatablesComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxMuiDatatablesModule = /** @class */ (function () {
        function NgxMuiDatatablesModule() {
        }
        NgxMuiDatatablesModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [MuiDatatablesComponent],
                        imports: [],
                        exports: [MuiDatatablesComponent]
                    },] }
        ];
        return NgxMuiDatatablesModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.MuiDatatablesComponent = MuiDatatablesComponent;
    exports.NgxMuiDatatablesModule = NgxMuiDatatablesModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-mui-datatables.umd.js.map